---
title: Credit Card - API Checkout
slug: en/nicepay-api-credit-card-payment-api-checkout
description: Information about API Checkout - Payment for Credit Card payment method provided by NICEPAY
image: https://archbee-image-uploads.s3.amazonaws.com/ZHvSjR5ZrsoxwKbJa3xmo/Y411twU9Jc--2CM6suSCh_microsoftteams-image.png
icon: {"faIcon":"fa-solid fa-credit-card"}
docTags: 
createdAt: 2022-12-19T10:12:43.000Z
---

# About Credit Card - API Checkout

***

There are several things that you must know when using Checkout API for Credit Card method so that your integration process will run smoothly with us:

1. Flow 3Ds/Non-3Ds Process.
2. Full Payment Feature.
3. Installment Feature.



# Process Flow

***

:::hint{type="info"}
Please visit the [Credit Card Feature](docId:5p_povP7Xv-oHKYiebAOC) page to check the explanation about 3Ds.
:::

## 3Ds

![CC Payment Flow - Redirect 3Ds](https://app.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/-B7a6C3IMu5oNYpnz84pR_nicepay-archbee-payment-cc-new-cc-redirect-3ds.png "CC Payment Flow - Redirect 3Ds")

Description steps of Redirect Credit Card payment flow with 3Ds:

1. The Customer does checkout.
2. The Customer sends checkout data to the Merchant.
3. The Merchant requests checkout using Registration API to NICEPAY.
4. NICEPAY registers the checkout data.
5. NICEPAY redirects Merchant to the NICEPAY's payment page.
6. The Merchant sends the NICEPAY's payment page to the Customer.
7. The Customer selects the payment method.
8. The Customer inputs the card data.
9. The Customer sends the information of card data to NICEPAY.
10. NICEPAY proceeds with the FDS calculation.
11. NICEPAY requests 3Ds to Bank.
12. Bank validates the 3Ds.
13. Bank sends 3Ds URL response to NICEPAY.
14. NICEPAY receives the verification response.
15. NICEPAY redirects the Customer to ACS authentication page.
16. Bank creates OTP response.
17. Bank sends OTP to the Customer.
18. The Customer receives OTP.
19. The Customer inputs OTP.
20. The Customer sends OTP to Bank.
21. Bank verifies the OTP.
22. Bank sends 3Ds result to NICEPAY.
23. NICEPAY receives the checking result.
24. NICEPAY requests the payment to Bank.
25. Bank proceeds the payment.
26. Bank sends payment notification to NICEPAY.
27. NICEPAY performs `callbackUrl` redirect to the Merchant.
28. The Merchant displays the `callbackUrl` result to the Customer.
29. NICEPAY sends payment notification to the Merchant.
30. The Merchant receives the notification.
31. The Merchant requests inquiry status to NICEPAY.
32. NICEPAY receives the request.
33. NICEPAY automatically sends status inquiry response to the Merchant.
34. The Merchant receives the final status.
35. The Merchant sends the transaction result page to the Customer.



## Non-3Ds

![CC Payment Flow - Redirect N 3Ds](https://app.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/eAcndroEzJ_AXG8-rTp7B_nicepay-archbee-payment-cc-redirect-non3ds.png "CC Payment Flow - Redirect N 3Ds")

Description steps of Redirect Credit Card payment flow with Non-3Ds:

1. The Customer performs checkout.
2. The Customer requests checkout to the Merchant.
3. The Merchant registers the checkout data.
4. The Merchant sends the response in the form of card data form.
5. The Customer requests checkout to the Merchant.
6. The Merchant registers the order using Registration API to NICEPAY.
7. NICEPAY stores the order registration.
8. NICEPAY redirects Merchants to the NICEPAY's page.
9. The Merchant sends NICEPAY's page to the Customer.
10. The Customer selects the payment method.
11. The Customer inputs card detail.
12. The Customer requests payment using Payment API to NICEPAY.
13. NICEPAY proceeds with the FDS calculation.
14. NICEPAY requests the payment to Bank.
15. Bank verifies the request.
16. Bank sends payment confirmation request to the Customer.
17. The Customer requests payment/charge to Bank.
18. Bank proceeds the payment.
19. Bank sends the response of payment to NICEPAY.
20. NICEPAY sends payment notification using `callBackUrl` and `dbProcessUrl` to the Merchant.
21. The Merchant receives the notification.
22. The Merchant requests status checking to NICEPAY.
23. NICEPAY sends the response of status checking.
24. The Merchant receives the final status.
25. The Merchant sends the order result to the Customer.



# NICEPAY Secure Payment Page

***

:::hint{type="info"}
Please open the [Credit Card Payment Guide](docId:90SA3OAOWSytgpJUBaayQ) page to provide your Customer with payment guide on the Credit Card method.
:::

![Secure Payment Page](https://api.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/5EARwUJAR5medSH9j-vpw_image-en-nicepay-secure-payment-page-main-dashboard.jpg "Secure Payment Page")

The image above is a payment sample with a Credit Card using NICEPAY Secure Payment Page.

After the Customer selects the Credit Card method, the Customer will ask to input their card data. NICEPAY system will automatically recognize the type of Customer's BIN card like in the picture below, such as VISA or Mastercard, American Express, etc, later the cards will be different according to the card types being used.

After completing the card data input, Your Customer can continue the payment process.

![Credit Card - Secure Payment Page](https://api.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/X3T5IlRddMuPSvSWHarcW_image-en-credit-card-secure-payment-page.jpg "Credit Card - Secure Payment Page")

Then, the transaction will run. Once the transaction is successful, then the display of the NICEPAY payment page will appear as the image as follows.

![Success - NICEPAY Secure Payment Page](https://api.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/pZlpRGQknjUiD0FL64erG_image-en-credit-card-success-secure-payment-page.jpg "Success - NICEPAY Secure Payment Page")

:::hint{type="info"}
Please visit the [Payment - API Checkout](docId\:o-4MmsbwXtZIb0ydniohw) page to know the next step regarding `payment handling`.
:::



# API Checkout Transaction Payment

***

| **API URL**         | `/nicepay/redirect/v2/payment`&#xD;         |
| ------------------- | ------------------------------------------- |
| **Request Method**  | `Redirect-GET`                              |
| **Header**          | `Content-Type: application/Form-UrlEncoded` |

:::hint{type="info"}
The endpoint above can use for Credit Card payment methods with Full Payment.
:::



# Full Payment Credit Card - API Checkout (CallbackUrl)

***

On the Full Payment Credit Card, the Customer paid fully the nominal billed at once. The following is the details API used on Credit Card payment.



## Request Parameter for Full Payment Credit Card - API Checkout (CallbackUrl)

***

| **Parameter**                                             | **Type** | **Size** | **Description**       | **Remark**                                                  |
| --------------------------------------------------------- | -------- | -------- | --------------------- | ----------------------------------------------------------- |
| `paymentURL`  <br /><font color="#2166ae">Required</font> | ANS      | 14       | Payment URL<br />     | https\://dev.nicepay.co.id/nicepay/redirect/v2/payment&#xD; |
| `tXid` <br /><font color="#2166ae">Required</font>        | AN       | 30       | Transaction ID	<br /> | IONPAYTEST00202203211640309389                              |

:::hint{type="info"}
For Checkout Payment API, Credit Card payment method with Full Payment and Installment got the same response.
:::



## Response Parameter for Full Payment Credit Card - API Checkout (CallbackUrl)

***



| **Parameter**    | **Type** | **Size** | **Description**                                                                                                                           | **Remark**                                                       |
| ---------------- | -------- | -------- | ----------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------- |
| `status`         | N        | 1        | [Transaction Status](docId\:QPNU5VtJKCzpxFRhiayAS)                                                                                        | 0                                                                |
| `tXid`           | AN       | 30       | Transaction ID                                                                                                                            | IONPAYTEST00202212201540174369<br /><br />When Success           |
| `referenceNo`    | AN       | 40       | Merchant Order Number                                                                                                                     | ordNo20221220151243<br /><br />When Success                      |
| `payMethod`      | N        | 2        | [Payment Method Code](docId\:NQ1y7vMa25ZtvQHN5He6W)                                                                                       | 01<br /><br />When Success                                       |
| `amt`            | N        | 12       | Transaction Amount                                                                                                                        | 1000<br /><br />When Success                                     |
| `notaxAmt`       | N        | 12       | Tax Fee Amount                                                                                                                            | 0<br /><br />When Success                                        |
| `vat`            | N        | 12       | Value Added Tax (VAT)                                                                                                                     | 0<br /><br />When Success                                        |
| `fee`            | N        | 12       | Service Fee                                                                                                                               | 0<br /><br />When Success                                        |
| `currency`       | A        | 3        | Currency                                                                                                                                  | IDR<br /><br />When Success                                      |
| `goodsNm`        | AN       | 100      | Goods Name                                                                                                                                | Goods+For+Testing+Credit+Card&#xD;<br /><br />When Success       |
| `billingNm`      | A        | 100      | Billing Name                                                                                                                              | John+Doe<br /><br />When Success                                 |
| `transDt`        | N        | 8        | Transaction Date (`YYYYMMDD`)	                                                                                                            | 20221220<br /><br />When Success                                 |
| `transTm`        | N        | 6        | Transaction Time (`HH24MISS`)	                                                                                                            | 154017<br /><br />When Success                                   |
| `authNo`         | N        | 10       | Approval Number                                                                                                                           | 174300<br /><br />When Success (Additional)                      |
| `issuBankCd`     | A        | 4        | [Issuing Bank Code](docId\:HlxvgrXVxWD90n8ohNKm0)                                                                                         | BMRI<br /><br />When Success                                     |
| `acquBankCd`     | A        | 4        | [Acquiring Bank Code](docId\:HlxvgrXVxWD90n8ohNKm0)                                                                                       | BMRI<br /><br />When Success                                     |
| `issuBankNm`     | A        | 255      | Issuing Bank Name                                                                                                                         | Mandiri<br /><br />When Success                                  |
| `acquBankNm`     | A        | 255      | Acquiring Bank Name                                                                                                                       | Mandiri<br /><br />When Success                                  |
| `ccTransType`    | AN<br /> | 2        | Credit Card Transaction Type:<br />`1`: Normal<br />`2`: Recurring<br />`3`: Pre-Auth<br />`4`: Capture                                   | 1<br /><br />When Success                                        |
| `cardNo`         | ANS      | 20       | Card Number with Masking                                                                                                                  | 46161111\*\*\*\*1111<br /><br />When Success                     |
| `cardExpYymm`    | N        | 4        | Card Expiration (`YYMM`)                                                                                                                  | 2707<br /><br />When Success                                     |
| `instmntType`    | N        | 2        | [Installment Type Code](docId:_Wzur5wjwhrDR8YXI-Ppi)                                                                                      | 1<br /><br />When Success                                        |
| `instmntMon`     | N        | 2        | Installment Month<br />`1`: 1 Month/Full Payment, *if* `instmntType`*: null/1*<br />`3`: 3 Months<br />`6`: 6 Months<br />`12`: 12 Months | 1<br /><br />When Success                                        |
| `recurringToken` | AN       | 255      | Recurring Token                                                                                                                           | null<br /><br />When Success                                     |
| `preauthToken`   | AN       | 255      | Pre-Auth Token                                                                                                                            | null<br /><br />When Success                                     |
| `matchCl`        | N        | 1        | [Notification Match Amount Indicator](docId\:HheZYw5iKlIptKqYyA5bI)                                                                       | 1<br /><br />When Success                                        |
| `merchantToken`  | AN       | 255      | Merchant Token                                                                                                                            | 8f5b330a549c167b53b4b9fd5f2d2eba897a64235c1610524074ec59f8884e8a |



Sample Parameter for Full Payment Credit Card - API Checkout (CallbackUrl)
--------------------------------------------------------------------------

***

### Request Parameter

:::CodeblockTabs
cURL

```curl
curl -X GET "https://www.merchant.com/callbackUrl?ccTransType=1&fee=0&tXid=IONPAYTEST00202212201540174369&amt=1000&notaxAmt=0&cardNo=46161111****1111&issuBankCd=BMRI&matchCl=1&preauthToken=null&cardExpYymm=2603&acquBankNm=Mandiri&payMethod=01&currency=IDR&instmntMon=1&cc_trans_type=1&issuBankNm=Mandiri&merchantToken=dc1dd9e57ff6c4db341654ae31e623cab4d4d8057b2d0b58bef43ccb0da3b494&goodsNm=Goods+For+Testing+Credit+Card&referenceNo=ordNo20221220151243&authNo=174300&transTm=154017&cpGuaranteeableStatus=null&recurringToken=null&vat=0&instmntType=1&billingNm=John+Doe&acquBankCd=BMRI&transDt=20221220&status=0"
```
:::

### Callback Parameter

:::CodeblockTabs
Response Callback

```curl
status=0
tXid=IONPAYTEST00202212201540174369
referenceNo=ordNo20221220151243
payMethod=01
amt=1000
notaxAmt=0
vat=0
fee=0
currency=IDR
goodsNm=Goods+For+Testing+Credit+Card
billingNm=John+Doe
transDt=20221220
transTm=154017
authNo=174300
issuBankCd=BMRI
acquBankCd=BMRI
issuBankNm=Mandiri
acquBankNm=Mandiri
ccTransType=1
cardNo=46161111****1111
cardExpYymm=2707
instmntType=1
instmntMon=1
recurringToken=null
preauthToken=null
matchCl=1
merchantToken=8f5b330a549c167b53b4b9fd5f2d2eba897a64235c1610524074ec59f8884e8a
```
:::

:::hint{type="info"}
Note: Response parameter will be sent through `callBackurl` with Content-type: `application/json` and method: `POST Parameter`.
:::

:::hint{type="success"}
For the Payment integration process on Checkout API, the Response from Request received after performing Call Request API is a `callback URL`.
:::



## Callback Handling API Checkout Payment

***

:::hint{type="info"}
The `tXid` won't be the same as the request hold. The capture process will reassure that the captured `amount` value doesn't exceed the funds owned.
:::

:::hint{type="success"}
When Your Callback already received `callbackUrl`, we recommended the Merchant to do the status verification using the [Status Inquiry - API Checkout](docId\:RhH7PmISd6IHN99yWVJHm).
:::

:::hint{type="warning"}
`Callback Handling` is very important to minimize the Fraud act, we highly recommend the Merchant to do the verification using `Callback parameter`.&#x20;
:::

::Image[]{src="https://app.archbee.com/api/optimize/ZHvSjR5ZrsoxwKbJa3xmo/ccwlMZjgo0gOioQqjK2oO_nicepay-api-checkout-api-callback-handling-flow-1.png" size="60" width="370" height="361" position="center" caption="Callback Handling Flow" alt="Callback Handling Flow" darkWidth="370" darkHeight="361" showCaption="true"}

:::CodeblockTabs
URL Callback

```json
"callbackUrl" : "https://www.merchant.com/callbackUrl/"
```

Response Callback

```json
{
    "resultCd":"0000",
    "resultMsg":"SUCCESS",
    "tXid":"IONPAYTEST01202212141112221428",
    "referenceNo":"",
    "payMethod":"01",
    "amt":"10000",
    "transDt":"20221212",
    "transTm":"121212",
    "description":"Testing Credit Card Transaction",
    "authNo":"080623",
    "issuBankCd":"OTHR"
    "acquBankCd":"BMRI",
    "cardNo":"453211*****1111",
    "goodsNm":"Test Transaction Nicepay"
    "billingNm":"John Doe",
    "currency":"IDR",
    "timeStamp":"20221212121212",
    "merchantToken":"2035d2295d9578fffb40137186f0203474142ae3e57992d4847826c5fcaffce6",
    "cardExpYymm":"2712",
    "instmntMon":"1",
    "instmntType":"1",
    "ccTransType":"1"
}
```
:::

